Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.pep
Class PEPService

    java.lang.Object
      org.jivesoftware.openfire.pep.PEPService

All Implemented Interfaces:
  Serializable, PubSubService, Cacheable

    public class PEPService

extends Object
implements PubSubService, Cacheable

A PEPService is a `PubSubService` for use with XEP-0163: "Personal Eventing via Pubsub" Version 1.0 Note: Although this class implements `Cacheable`, instances should only be cached in caches that have time-based (as opposed to size-based) eviction policies.

Author:
  Armando Jagucki
See Also:
  Serialized Form

Constructor Summary
`PEPService(XMPPServer server, String bareJID)` Constructs a PEPService.

Method Summary
`void` | `addNode(Node node)` Adds an already persistent node to the service.
`void` | `broadcast(Node node, org.xmpp.packet.Message message, Collection<org.xmpp.packet.JID> jids)` Broadcasts the specified Message containing an event notification to a list of subscribers to the specified node.
`boolean` | `canCreateNode(org.xmpp.packet.JID creator)` Returns true if the pubsub service allows the specified user to create nodes.
`org.xmpp.packet.JID` | `getAddress()` Returns the XMPP address of the service.
`Map<String,Map<String,String>>` | `getBarePresences()` Returns a registry of the presence's show value of users that subscribed to a node of the pubsub service and for which the node only delivers notifications for online users or node subscriptions deliver events based on the user presence show value.
`int` | `getCachedSize()` Returns the approximate size of the Object in bytes.
`DefaultNodeConfiguration` | `getDefaultNodeConfiguration(boolean leafType)` Returns the default node configuration for the specified node type or `null` if the specified node type is not supported by the service.
`int` | `getItemsTaskTimeout()` Returns the timeout value for the published items maintenance task.
`Queue<PublishedItem>` | `getItemsToAdd()` Gets the queue that holds the items that need to be added to the database.
`Queue<PublishedItem>` | `getItemsToDelete()` Gets the queue that holds the items that need to be deleted from the database.
`AdHocCommandManager` | `getManager()` Returns the ad-hoc commands manager used for this service.
`Node` | `getNode(String nodeID)` Returns the `Node` that matches the specified node ID or `null` if none was found.
`Collection<Node>` | `getNodes()` Retuns the collection of nodes hosted by the pubsub service.
`PublishedItemTask` | `getPublishedItemTask()` Returns the published item task used for this service.
`CollectionNode` | `getRootCollectionNode()` Returns the `CollectionNode` that acts as the root node of the entire node hierarchy.
`String` | `getServiceID()` Returns a String that uniquely identifies this pubsub service.
`Collection<String>` | `getShowPresences(org.xmpp.packet.JID subscriber)` Returns the show values of the last know presence of all connected resources of the specified subscriber.
`Timer` | `getTimer()` Returns the timer used for the maintenance process of this service.
`boolean` | `isCollectionNodesSupported()` Returns true if the pubsub service supports collection nodes.
`boolean` | `isInstantNodeSupported()` Returns true if the pubsub service allows users to create nodes without specifying the node ID.
`boolean` | `isMultipleSubscriptionsEnabled()` Returns true if a user may have more than one subscription with the node.
`boolean` | `isNodeCreationRestricted()`
`boolean` | `isServiceAdmin(org.xmpp.packet.JID user)` Returns true if the specified user is a sysadmin of the pubsub service or has admin privileges.
`void` | `presenceSubscriptionNotRequired(Node node, org.xmpp.packet.JID user)` Requests the pubsub service to unsubscribe from the presence of the user.
`void` | `presenceSubscriptionRequired(Node node, org.xmpp.packet.JID user)` Requests the pubsub service to subscribe to the presence of the user.
`void` | `queueItemToAdd(PublishedItem newItem)` Adds the item to the queue of items to add to the database.
`void` | `queueItemToRemove(PublishedItem removedItem)` Adds the item to the queue of items to remove from the database.
`void` | `removeNode(String nodeID)` Removes the specified node from the service.
`void` | `send(org.xmpp.packet.Packet packet)` Sends the specified packet.
`void` | `sendLastPublishedItems(org.xmpp.packet.JID recipientJID)` Sends an event notification for the last published item of each leaf node under the root collection node to the recipient JID.
`void` | `sendNotification(Node node, org.xmpp.packet.Message message, org.xmpp.packet.JID recipientJID)` Sends the specified Message containing an event notification to a specific subscriber of the specified node.
`void` | `setItemsTaskTimeout(int timeout)` Sets the timeout value for the published items maintenance task.
`void` | `setPublishedItemTask(PublishedItemTask task)` Sets the published item task used for this service.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PEPService

    public PEPService(XMPPServer server,
                      String bareJID)

  Constructs a PEPService.

  Parameters:
    `server` - the XMPP server.
    `bareJID` - the bare JID (service ID) of the user owning the service.

Method Detail

### addNode

    public void addNode(Node node)

  Description copied from interface: `PubSubService`
  Adds an already persistent node to the service.

  Specified by:
    `addNode` in interface `PubSubService`
  Parameters:
    `node` - the persistent node to add to the service.

### removeNode

    public void removeNode(String nodeID)

  Description copied from interface: `PubSubService`
  Removes the specified node from the service. Most probaly the node was deleted from the database as well.

  A future version may support unloading of inactive nodes even though they may still exist in the database.

  Specified by:
    `removeNode` in interface `PubSubService`
  Parameters:
    `nodeID` - the ID that uniquely identifies the node in the pubsub service.

### getNode

    public Node getNode(String nodeID)

  Description copied from interface: `PubSubService`
  Returns the `Node` that matches the specified node ID or `null` if none was found.

  Specified by:
    `getNode` in interface `PubSubService`
  Parameters:
    `nodeID` - the ID that uniquely identifies the node in the pubsub service.
  Returns:
    the Node that matches the specified node ID or `null` if none was found.

### getNodes

    public Collection<Node> getNodes()

  Description copied from interface: `PubSubService`
  Retuns the collection of nodes hosted by the pubsub service. The collection does not support modifications.

  Specified by:
    `getNodes` in interface `PubSubService`
  Returns:
    the collection of nodes hosted by the pubsub service.

### getRootCollectionNode

    public CollectionNode getRootCollectionNode()

  Description copied from interface: `PubSubService`
  Returns the `CollectionNode` that acts as the root node of the entire node hierarchy. The returned node does not have a node identifier. If collection nodes is not supported then return `null`.

  Specified by:
    `getRootCollectionNode` in interface `PubSubService`
  Returns:
    the CollectionNode that acts as the root node of the entire node hierarchy or `null` if collection nodes is not supported.

### getAddress

    public org.xmpp.packet.JID getAddress()

  Description copied from interface: `PubSubService`
  Returns the XMPP address of the service.

  Specified by:
    `getAddress` in interface `PubSubService`
  Returns:
    the XMPP address of the service.

### getServiceID

    public String getServiceID()

  Description copied from interface: `PubSubService`
  Returns a String that uniquely identifies this pubsub service. This information is being used when storing node information in the database so it's possible to have nodes with the same ID but under different pubsub services.

  Specified by:
    `getServiceID` in interface `PubSubService`
  Returns:
    a String that uniquely identifies this pubsub service.

### getDefaultNodeConfiguration

    public DefaultNodeConfiguration getDefaultNodeConfiguration(boolean leafType)

  Description copied from interface: `PubSubService`
  Returns the default node configuration for the specified node type or `null` if the specified node type is not supported by the service.

  Specified by:
    `getDefaultNodeConfiguration` in interface `PubSubService`
  Parameters:
    `leafType` - true when requesting default configuration of leaf nodes
  Returns:
    the default node configuration for the specified node type or `null` if the specified node type is not supported by the service.

### getShowPresences

    public Collection<String> getShowPresences(org.xmpp.packet.JID subscriber)

  Description copied from interface: `PubSubService`
  Returns the show values of the last know presence of all connected resources of the specified subscriber. When the subscriber JID is a bare JID then the answered collection will have many entries one for each connected resource. Moreover, if the user is offline then an empty collectin is returned. Available show status is represented by a `online` value. The rest of the possible show values as defined in RFC 3921.

  Specified by:
    `getShowPresences` in interface `PubSubService`
  Parameters:
    `subscriber` - the JID of the subscriber. This is not the JID of the affiliate.
  Returns:
    an empty collection when offline. Otherwise, a collection with the show value of each connected resource.

### canCreateNode

    public boolean canCreateNode(org.xmpp.packet.JID creator)

  Description copied from interface: `PubSubService`
  Returns true if the pubsub service allows the specified user to create nodes.

  Specified by:
    `canCreateNode` in interface `PubSubService`
  Parameters:
    `creator` - the JID of the entity trying to create a new node.
  Returns:
    true if the pubsub service allows the specified user to create nodes.

### isCollectionNodesSupported

    public boolean isCollectionNodesSupported()

  Description copied from interface: `PubSubService`
  Returns true if the pubsub service supports collection nodes. When collection nodes is supported it is possible to create hierarchy of nodes where a `CollectionNode` may only hold children nodes of type `CollectionNode` or `LeafNode`. On the other hand, `LeafNode` can only hold `PublishedItem`.

  Specified by:
    `isCollectionNodesSupported` in interface `PubSubService`
  Returns:
    true if the pubsub service supports collection nodes.

### isInstantNodeSupported

    public boolean isInstantNodeSupported()

  Description copied from interface: `PubSubService`
  Returns true if the pubsub service allows users to create nodes without specifying the node ID. The service will create a random node ID and assigne it to the node.

  Specified by:
    `isInstantNodeSupported` in interface `PubSubService`
  Returns:
    true if the pubsub service allows users to create nodes without specifying the node ID.

### isMultipleSubscriptionsEnabled

    public boolean isMultipleSubscriptionsEnabled()

  Description copied from interface: `PubSubService`
  Returns true if a user may have more than one subscription with the node. When multiple subscriptions is enabled each subscription request, event notification and unsubscription request should include a `subid` attribute.

  Specified by:
    `isMultipleSubscriptionsEnabled` in interface `PubSubService`
  Returns:
    true if a user may have more than one subscription with the node.

### isServiceAdmin

    public boolean isServiceAdmin(org.xmpp.packet.JID user)

  Description copied from interface: `PubSubService`
  Returns true if the specified user is a sysadmin of the pubsub service or has admin privileges.

  Specified by:
    `isServiceAdmin` in interface `PubSubService`
  Parameters:
    `user` - the user to check if he has admin privileges.
  Returns:
    true if the specified user is a sysadmin of the pubsub service or has admin privileges.

### isNodeCreationRestricted

    public boolean isNodeCreationRestricted()

### presenceSubscriptionNotRequired

    public void presenceSubscriptionNotRequired(Node node,
                                                org.xmpp.packet.JID user)

  Description copied from interface: `PubSubService`
  Requests the pubsub service to unsubscribe from the presence of the user. If the service was not subscribed to the user's presence or any node still requires to be subscribed to the user presence then do nothing.

  Specified by:
    `presenceSubscriptionNotRequired` in interface `PubSubService`
  Parameters:
    `node` - the node that originated the unsubscription request.
    `user` - the JID of the affiliate to unsubscribe from his presence.

### presenceSubscriptionRequired

    public void presenceSubscriptionRequired(Node node,
                                             org.xmpp.packet.JID user)

  Description copied from interface: `PubSubService`
  Requests the pubsub service to subscribe to the presence of the user. If the service has already subscribed to the user's presence then do nothing.

  Specified by:
    `presenceSubscriptionRequired` in interface `PubSubService`
  Parameters:
    `node` - the node that originated the subscription request.
    `user` - the JID of the affiliate to subscribe to his presence.

### send

    public void send(org.xmpp.packet.Packet packet)

  Description copied from interface: `PubSubService`
  Sends the specified packet.

  Specified by:
    `send` in interface `PubSubService`
  Parameters:
    `packet` - the packet to send.

### broadcast

    public void broadcast(Node node,
                          org.xmpp.packet.Message message,
                          Collection<org.xmpp.packet.JID> jids)

  Description copied from interface: `PubSubService`
  Broadcasts the specified Message containing an event notification to a list of subscribers to the specified node. Each message being sent has to have a unique ID value so that the service can properly track any notification-related errors that may occur.

  Specified by:
    `broadcast` in interface `PubSubService`
  Parameters:
    `node` - the node that triggered the event notification.
    `message` - the message containing the event notification.
    `jids` - the list of entities to get the event notification.

### sendNotification

    public void sendNotification(Node node,
                                 org.xmpp.packet.Message message,
                                 org.xmpp.packet.JID recipientJID)

  Description copied from interface: `PubSubService`
  Sends the specified Message containing an event notification to a specific subscriber of the specified node. The message being sent has to have a unique ID value so that the service can properly track any notification-related errors that may occur.

  Specified by:
    `sendNotification` in interface `PubSubService`
  Parameters:
    `node` - the node that triggered the event notification.
    `message` - the message containing the event notification.
    `recipientJID` - the entity to get the event notification.

### sendLastPublishedItems

    public void sendLastPublishedItems(org.xmpp.packet.JID recipientJID)

  Sends an event notification for the last published item of each leaf node under the root collection node to the recipient JID. If the recipient has no subscription to the root collection node, has not yet been authorized, or is pending to be configured -- then no notifications are going to be sent.

  Depending on the subscription configuration the event notifications may or may not have a payload, may not be sent if a keyword (i.e. filter) was defined and it was not matched.

  Parameters:
    `recipientJID` - the recipient that is to receive the last published item notifications.

### queueItemToAdd

    public void queueItemToAdd(PublishedItem newItem)

  Description copied from interface: `PubSubService`
  Adds the item to the queue of items to add to the database. The queue is going to be processed by another thread.

  Specified by:
    `queueItemToAdd` in interface `PubSubService`
  Parameters:
    `newItem` - the item to add to the database.

### queueItemToRemove

    public void queueItemToRemove(PublishedItem removedItem)

  Description copied from interface: `PubSubService`
  Adds the item to the queue of items to remove from the database. The queue is going to be processed by another thread.

  Specified by:
    `queueItemToRemove` in interface `PubSubService`
  Parameters:
    `removedItem` - the item to remove from the database.

### getBarePresences

    public Map<String,Map<String,String>> getBarePresences()

  Description copied from interface: `PubSubService`
  Returns a registry of the presence's show value of users that subscribed to a node of the pubsub service and for which the node only delivers notifications for online users or node subscriptions deliver events based on the user presence show value. Offline users will not have an entry in the map. Note: Key-> bare JID and Value-> Map whose key is full JID of connected resource and value is show value of the last received presence.

  Specified by:
    `getBarePresences` in interface `PubSubService`
  Returns:
    a registry of the presence's show value of users that subscribed to a node of the pubsub service.

### getItemsToAdd

    public Queue<PublishedItem> getItemsToAdd()

  Description copied from interface: `PubSubService`
  Gets the queue that holds the items that need to be added to the database.

  Specified by:
    `getItemsToAdd` in interface `PubSubService`
  Returns:
    the queue that holds the items that need to be added to the database.

### getItemsToDelete

    public Queue<PublishedItem> getItemsToDelete()

  Description copied from interface: `PubSubService`
  Gets the queue that holds the items that need to be deleted from the database.

  Specified by:
    `getItemsToDelete` in interface `PubSubService`
  Returns:
    the queue that holds the items that need to be deleted from the database.

### getManager

    public AdHocCommandManager getManager()

  Description copied from interface: `PubSubService`
  Returns the ad-hoc commands manager used for this service.

  Specified by:
    `getManager` in interface `PubSubService`
  Returns:
    the ad-hoc commands manager used for this service.

### getPublishedItemTask

    public PublishedItemTask getPublishedItemTask()

  Description copied from interface: `PubSubService`
  Returns the published item task used for this service.

  Specified by:
    `getPublishedItemTask` in interface `PubSubService`
  Returns:
    the published item task used for this service.

### setPublishedItemTask

    public void setPublishedItemTask(PublishedItemTask task)

  Description copied from interface: `PubSubService`
  Sets the published item task used for this service.

  Specified by:
    `setPublishedItemTask` in interface `PubSubService`
  Parameters:
    `task` - the PublishedItemTask to set for this service.

### getTimer

    public Timer getTimer()

  Description copied from interface: `PubSubService`
  Returns the timer used for the maintenance process of this service.

  Specified by:
    `getTimer` in interface `PubSubService`
  Returns:
    the timer used for the maintenance process of this service.

### getItemsTaskTimeout

    public int getItemsTaskTimeout()

  Description copied from interface: `PubSubService`
  Returns the timeout value for the published items maintenance task.

  Specified by:
    `getItemsTaskTimeout` in interface `PubSubService`
  Returns:
    the timeout value for the published items maintenance task.

### setItemsTaskTimeout

    public void setItemsTaskTimeout(int timeout)

  Description copied from interface: `PubSubService`
  Sets the timeout value for the published items maintenance task.

  Specified by:
    `setItemsTaskTimeout` in interface `PubSubService`
  Parameters:
    `timeout` - the timeout value for the published items maintenance task.

### getCachedSize

    public int getCachedSize()

  Description copied from interface: `Cacheable`
  Returns the approximate size of the Object in bytes. The size should be considered to be a best estimate of how much memory the Object occupies and may be based on empirical trials or dynamic calculations.

  Specified by:
    `getCachedSize` in interface `Cacheable`
  Returns:
    the size of the Object in bytes.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.